<template>
  <v-dialog persistent
    v-model="showMoveItemsDialogue"
    max-width="500">
    <v-card style="height:500px;postition:relative;">
      <v-progress-linear
        v-if="moveItemRequested"
        :indeterminate="true"
        height="7"
        color="success"
        style="height: 7px;position: absolute;top: -16px;">
      </v-progress-linear>
      <v-subheader>
        <h4 style="color:rgb(80, 130, 150)">
          Move items
        </h4>
        <v-spacer></v-spacer>
        <v-btn icon
          style="color:#757575"
          @click="closeModalWindowClicked()">
          <v-icon>
            close
          </v-icon>
        </v-btn>
      </v-subheader>
      <v-divider></v-divider>
        <v-card-actions>
          <default-spinner-component
            :loading-message="loadingMessage"
            v-if="loadingStoresList"
            style="left:45%;margin-top:50px;"/>
            <v-container v-if="showMoveItemsForm">
              <form class="login"
                @submit.prevent="$v.$touch(); if($v.$error === false){onMoveItemSubmit()};">
                <div style="height:40px;">
                  <span class="detailLabel">
                    From
                  </span>
                  &nbsp;&nbsp; {{moveItemInfo.shopName}}
                </div>
                <div style="height:40px;">
                  <span class="detailLabel">
                    Brand
                  </span>
                  &nbsp;&nbsp; {{moveItemInfo.brand}}
                </div>
                <div style="position:relative;"
                  v-bind:class="{ 'form-group--error': $v.selectedSize.$error }">
                  <span class="detailLabel"
                    style="position:absolute;top:20px;">
                    Size
                  </span>
                  <v-select
                    :items="sizesList"
                    v-model.trim="selectedSize"
                    @input="$v.selectedSize.$touch()"
                    v-on:input="$v.selectedSize.$touch"
                    label="Select"
                    single-line
                    style="width:75%;margin-left:40px;height:50px;">
                  </v-select>
                  <span class="formErrorMessage"
                    style="bottom:-20px;"
                    v-if="!$v.selectedSize.required && $v.selectedSize.$dirty">
                    Required
                  </span>
                </div>
                <div>
                  <v-layout row justify-space-between
                    v-if="showNumberSelection"
                    style="margin-top:40px;">
                    <div class="defaultInputContainer"
                      v-bind:class="{ 'form-group--error': $v.numberOfItemsToBeMoved.$error }"
                      style="width:auto;margin-top:0px;">
                      <input id="numberOfItemsToBeMoved"
                        class="inputDefault"
                        type="number"
                        v-model.trim="numberOfItemsToBeMoved"
                        @input="$v.numberOfItemsToBeMoved.$touch()"
                        v-on:input="$v.numberOfItemsToBeMoved.$touch"
                        v-bind:class="{
                          error: $v.numberOfItemsToBeMoved.$error,
                          valid: $v.numberOfItemsToBeMoved.$dirty && !$v.numberOfItemsToBeMoved.$invalid
                          }"
                        style="width:100px;"/>
                      <label for="numberOfItemsToBeMoved"
                        class="defaultInputPlaceholder">
                        Number
                      </label>
                      <span class="formErrorMessage"
                        v-if="!$v.numberOfItemsToBeMoved.required && $v.numberOfItemsToBeMoved.$dirty">
                        Required
                      </span>
                      <v-icon style="color:#5A5"
                        v-if="$v.numberOfItemsToBeMoved.$dirty && !$v.numberOfItemsToBeMoved.$invalid">
                        check_circle
                      </v-icon>
                      <span class="detailLabel">
                        of
                      </span>
                      &nbsp;&nbsp;{{allNumbers}}
                    </div>
                  </v-layout>
                </div>
                <div style="position:relative;"
                  v-if="showDestinationStoreSelection"
                  v-bind:class="{ 'form-group--error': $v.selectedAdress.$error }">
                  <span class="detailLabel"
                    style="position:absolute;top:20px;">
                    To
                  </span>
                  <v-select
                    :items="allStoresList"
                    v-model.trim="selectedAdress"
                    @input="$v.selectedAdress.$touch()"
                    v-on:input="$v.selectedAdress.$touch"
                    label="Select"
                    single-line
                    style="width:75%;margin-left:40px;height:50px;">
                  </v-select>
                  <span class="formErrorMessage"
                    style="bottom:-20px;"
                    v-if="!$v.selectedAdress.required && $v.selectedAdress.$dirty">
                    Required
                  </span>
                </div>
                <v-btn  v-if="selectedAdress"
                  color="darkSecondary"
                  block
                  depressed
                  dark
                  type="submit"
                  style="width:90%;margin:30px auto 0px auto;">
                    MOVE ITEM
                </v-btn>
              </form>
            </v-container>
          </v-card-actions>
        </v-card>
  </v-dialog>
</template>
<script>
import DefaultSpinnerComponent from './../common/spinner.vue'
import axios from 'axios'
import { required } from 'vuelidate/lib/validators'
export default {
  name: 'MoveItem',
  components: {
    DefaultSpinnerComponent
  },
  data: () => ({
    moveItemRequested: false,
    loadingStoresList: true,
    showMoveItemsForm: false,
    loadingMessage: 'Loading stores list ...',
    allStoresList: [],
    selectedAdress: null,
    selectedSize: null,
    showNumberSelection: false,
    showDestinationStoreSelection: false,
    numberOfItemsToBeMoved: undefined,
    allNumbers: 0
  }),
  computed: {
    showMoveItemsDialogue () {
      return this.$store.state.stockModule.moveItemFromToStore
    },
    moveItemInfo () {
      return this.$store.state.stockModule.moveItemInfo
    },
    sizesList () {
      let rawItemToBeMoved = this.$store.state.stockModule.moveItemInfo
      let sizesList = []
      rawItemToBeMoved.sizes.forEach(element => {
        if (sizesList.includes(element.size) === false) {
          sizesList.push(element.size)
        }
      })
      return sizesList
    }
  },
  methods: {
    onMoveItemSubmit () {
      let selectedItem = this.$store.state.stockModule.moveItemInfo
      let movedItem = {
        itemName: this.$route.params.id,
        from: selectedItem.shopName,
        brand: selectedItem.brand,
        size: this.selectedSize,
        number: this.numberOfItemsToBeMoved,
        to: this.selectedAdress
      }
      axios.post('/move_item', movedItem)
        .then(response => {
          this.$router.go()
          this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Succesfully moved an item')
        })
        .catch(error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on moving item: ' + error)
        })
    },
    closeModalWindowClicked () {
      this.$store.commit('CLOSE_MOVE_ITEMS_MODAL')
    }
  },
  watch: {
    selectedSize (val) {
      if (val !== null) {
        this.showNumberSelection = true
        this.allStoresList = this.allStoresList.filter(element => element !== this.moveItemInfo.shopName)
        this.moveItemInfo.sizes.forEach(element => {
          if (element.size === this.selectedSize) {
            this.allNumbers = element.number
          }
        })
      } else {
        this.showNumberSelection = false
      }
    },
    numberOfItemsToBeMoved (val) {
      val !== undefined ? this.showDestinationStoreSelection = true
        : this.showDestinationStoreSelection = false
    }
  },
  created () {
    this.loadingStoresList = true
    axios.get('store')
      .then(response => {
        setTimeout(() => {
          this.allStoresList = response.data
          this.loadingStoresList = false
          this.showMoveItemsForm = true
        }, 2000)
      })
      .catch(error => {
        this.loadingStoresList = false
        this.showMoveItemsForm = false
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Eroor in getting all strores list: ' + error)
      })
  },
  validations: {
    numberOfItemsToBeMoved: {
      required
    },
    selectedAdress: {
      required
    },
    selectedSize: {
      required
    }
  }
}
</script>
